<div
  class='input-geometry'
  ...attributes
  {{did-update this.checkPointCoordinates @extent}}
  {{did-update this.updateExtent @extent}}
  {{did-update this.updateEditState @disabled}}
  {{did-insert this.setup}}
>
  {{#if this.showToolbar}}
    <div class='btn-toolbar' role='toolbar' aria-label='Map editor toolbar'>
      <div
        class='btn-group btn-group-source me-2 mb-3'
        role='group'
        aria-label='Geometry source'
      >
        <button
          type='button'
          disabled={{this.isEdit}}
          class='btn btn-edit
            {{if this.isEdit "btn-success" "btn-outline-secondary"}}'
          {{on 'click' (fn this.selectMode 'edit')}}
          data-placement='bottom'
          title={{t 'edit'}}
        >
          <FaIcon @icon='pencil-alt' />
        </button>

        <button
          type='button'
          disabled={{this.isPaste}}
          class='btn btn-paste
            {{if this.isPaste "btn-success" "btn-outline-secondary"}}'
          {{on 'click' (fn this.selectMode 'paste')}}
          data-placement='bottom'
          title={{t 'geoJson editor'}}
        >
          <FaIcon @icon='font' />
        </button>

        <button
          type='button'
          disabled={{this.isFile}}
          class='btn btn-file
            {{if this.isFile "btn-success" "btn-outline-secondary"}}'
          {{on 'click' (fn this.selectMode 'file')}}
          data-placement='bottom'
          title={{t 'select file'}}
        >
          <FaIcon @icon='file' />
        </button>
      </div>

      {{#if this.isEdit}}
        <div
          class='btn-group btn-group-operations me-2 mb-3'
          role='group'
          aria-label='Draw operations'
        >
          <button
            type='button'
            disabled={{this.isPoint}}
            class='btn btn-point
              {{if this.isPoint "btn-success" "btn-outline-secondary"}}'
            {{on 'click' this.createPoint}}
            data-placement='bottom'
            title={{t 'create point'}}
          >
            <FaIcon @icon='map-marker-alt' />
          </button>

          <button
            type='button'
            disabled={{this.isNewLine}}
            class='btn btn-line
              {{if this.isNewLine "btn-success" "btn-outline-secondary"}}'
            {{on 'click' this.createLine}}
            data-placement='bottom'
            title={{t 'create line'}}
          >
            <FaIcon @icon='grip-lines' />
          </button>

          <button
            type='button'
            disabled={{this.isNewPolygon}}
            class='btn btn-polygon
              {{if this.isNewPolygon "btn-success" "btn-outline-secondary"}}'
            {{on 'click' this.createPolygon}}
            data-placement='bottom'
            title={{t 'create polygon'}}
          >
            <FaIcon @icon='draw-polygon' />
          </button>
        </div>

        <div
          class='btn-group btn-group-operations me-2 mb-3'
          role='group'
          aria-label='Edit operations'
        >
          <button
            type='button'
            disabled={{this.isEditPath}}
            class='btn btn-edit-path
              {{if this.isEditPath "btn-success" "btn-outline-secondary"}}'
            data-placement='bottom'
            title={{t 'edit geometry'}}
          >
            <FaIcon @icon='mouse-pointer' />
          </button>
        </div>
      {{/if}}
    </div>
  {{/if}}

  {{#if this.isEdit}}
    <div class='map-container'>
      <Map::Plain as |map|>
        <Map::Layer::Base
          @map={{map}}
          @value={{this.selectedBaseMap}}
          @onSetupError={{this.layerSetupError}}
        />

        <Map::View
          @map={{map}}
          @extentM={{this.extentM}}
          @onChangeCenter={{fn this.changeMapView map}}
        />

        {{#if this.extent}}
          <Map::Layer::Vector
            @style={{this.extentStyle}}
            @map={{map}}
            as |vector source|
          >
            <Map::Features::Geojson::Polygon
              @source={{source}}
              @value={{this.extent}}
            />
          </Map::Layer::Vector>
        {{/if}}

        {{#if this.disabled}}
          <Map::Feature @map={{map}} @value={{@value}} @icon={{@icon}} />
        {{/if}}

        {{#unless this.disabled}}
          {{#if this.isPoint}}
            <Map::MapCenterMarker
              @message={{t 'message-map-marker-point-move'}}
            />
          {{/if}}

          {{#if this.isNewLine}}
            <Map::Layer::Vector @map={{map}} as |vector source|>
              <Map::Interaction::Draw
                @map={{map}}
                @type='LineString'
                @source={{source}}
                @onDrawEnd={{this.newLine}}
              />
            </Map::Layer::Vector>
          {{/if}}

          {{#if this.isNewPolygon}}
            <Map::Layer::Vector @map={{map}} as |vector source|>
              <Map::Interaction::Draw
                @map={{map}}
                @type='Polygon'
                @source={{source}}
                @onDrawEnd={{this.newPolygon}}
              />
            </Map::Layer::Vector>
          {{/if}}

          {{#if this.isEditPath}}
            <Map::Layer::Vector @map={{map}} as |vector source|>
              {{#if (eq this.type 'Polygon')}}
                <Map::Features::Geojson::Polygon
                  @source={{source}}
                  @value={{@value}}
                />
              {{/if}}

              {{#if (eq this.type 'MultiPolygon')}}
                <Map::Features::Geojson::MultiPolygon
                  @source={{source}}
                  @value={{@value}}
                />
              {{/if}}

              {{#if (eq this.type 'LineString')}}
                <Map::Features::Geojson::Line
                  @source={{source}}
                  @value={{@value}}
                />
              {{/if}}

              {{#if (eq this.type 'MultiLineString')}}
                <Map::Features::Geojson::MultiLine
                  @source={{source}}
                  @value={{@value}}
                />
              {{/if}}

              <Map::Interaction::Select
                @map={{map}}
                @layer={{vector}}
                as |select features|
              >
                <Map::Interaction::Modify
                  @map={{map}}
                  @features={{features}}
                  @onChange={{this.featureChange}}
                />
              </Map::Interaction::Select>
            </Map::Layer::Vector>
          {{/if}}
        {{/unless}}

        <Map::Container @right={{true}} @bottom={{true}}>
          <Map::Controls @map={{map}} />
          <Map::BaseMapSelect
            @list={{this.baseMaps}}
            @selected={{this.selectedBaseMap}}
            @onSelect={{this.selectBaseMap}}
          />
        </Map::Container>
      </Map::Plain>
    </div>
  {{/if}}

  {{#if this.isPaste}}
    {{!-- template-lint-disable require-input-label --}}
    <Textarea
      class='form-control input-geo-json'
      @value={{this.jsonStringValue}}
      rows='6'
    />
  {{/if}}

  {{#if this.isFile}}
    <Input::File
      @onTextContentChange={{this.fileContent}}
      @error={{this.fileError}}
      @info={{t 'geojson-feature-file-message'}}
    />
  {{/if}}
</div>